#ifdef __cplusplus
extern "C" {
#include <cstdint>
#include <cstring>
#else
#include <stdint.h>
#include <string.h>
#endif


#define PANAKO_AUDIO_BLOCK_SIZE 1 << 17

#define PANAKO_FREQ_MAX_FILTER_SIZE 103
#define PANAKO_TIME_MAX_FILTER_SIZE 25

#define PANAKO_FP_MIN_FREQ_DIST 1
#define PANAKO_FP_MAX_FREQ_DIST 128
#define PANAKO_FP_MIN_TIME_DIST 2
#define PANAKO_FP_MAX_TIME_DIST 33

#define PANAKO_SAMPLE_RATE 16000

#define PANAKO_TRANSF_MIN_FREQ 110
#define PANAKO_TRANSF_MAX_FREQ 7040
#define PANAKO_TRANSF_REF_FREQ 440
#define PANAKO_TRANSF_BANDS_PER_OCTAVE 85

extern uintptr_t new_point_processor(int sampleRate, int channels, int time_resolution_in_ms);

extern void point_processor_process(uintptr_t ptr, float* data, size_t data_size);

extern const uint8_t* point_processor_finish(uintptr_t ptr, uint32_t use_compact_hash, uint32_t use_packed_print, size_t* result_size);

extern void delete_point_processor(uintptr_t ptr);

#ifdef __cplusplus
}
#endif