#include "hibiki.h"
#include <cstdio>
#include <iostream>
#include <sstream>
#include <vector>
#include <iomanip>

int main() {

    auto fp = fopen("test.raw", "r");

    if (fp == nullptr){
        return 1;
    }

    auto ptr = new_point_processor(PANAKO_SAMPLE_RATE, 1, 8);

    float audioData[PANAKO_AUDIO_BLOCK_SIZE];

    while (true){
        auto read = fread(&audioData[0], sizeof(audioData[0]), sizeof(audioData) / sizeof(audioData[0]), fp);

        if (read > 0){
            point_processor_process(ptr, &audioData[0], read);
        }

        if (read < sizeof(audioData) / sizeof(audioData[0])) { //EOF
            break;
        }
    }

    size_t size;
    auto result = point_processor_finish(ptr, true, true, &size);

    std::vector<uint8_t> v(result, result + size);
    std::stringstream ss;
    ss << std::hex << std::setfill('0');
    std::vector<uint8_t>::const_iterator it;

    for (it = v.begin(); it != v.end(); it++) {
        ss << std::setw(2) << static_cast<unsigned>(*it);
    }

    std::cout << ss.str() << std::endl;


    fclose(fp);

    delete_point_processor(ptr);
    return 0;
}